---------------------------------------------------------- CBusT
library ieee;
use ieee.std_logic_1164.all;

entity CBusTE is                                    
  port (En : in std_logic; 
        Bi : in std_logic_vector(3 downto 0); 
        Bo : out std_logic_vector(3 downto 0);        
        B  : inout std_logic_vector(3 downto 0));                          
end CBusTE;                             

architecture CBusTA of CBusTE is         
begin                                                         



end CBusTA; 

--------------------------------------------------------- Testbench
-- pragma synthesis_off 
                            
library ieee;
use ieee.std_logic_1164.all;
use work.UtilPack.all;

entity CBusTTbE is
  generic (ClockT : time := 1 ns);                                           
end CBusTTbE;                                                

architecture CBusTTbA of CBusTTbE is                         
  component CBusTE                      
    port (En : in std_logic; 
          Bi : in std_logic_vector(3 downto 0); 
          Bo : out std_logic_vector(3 downto 0);        
          B  : inout std_logic_vector(3 downto 0));                                              
  end component;                                             
  signal EnS : std_logic := '0'; 
  signal BiS, BoS, BS : std_logic_vector(3 downto 0);   
begin                                                        
  CBusTI: CBusTE                           
    port map(En => EnS, Bi => BiS, Bo => BoS, B => BS);      
                                
  BiS <= "0000" after 1*ClockT,
         "0001" after 3*ClockT;         
 
  EnS <= '0' after 0*ClockT,                                
         '1' after 2*ClockT,
         '0' after 4*ClockT,                                
         '1' after 6*ClockT,
         '0' after 8*ClockT,                                
         '1' after 10*ClockT;

  StopSim(12 ns);
        
end CBusTTbA;  
-- pragma synthesis_on     