library ieee;
use ieee.std_logic_1164.all;
use std.textio.all;
use work.UtilPack.all;
use work.ClockPack.all;

entity ClockE is
end ClockE;

architecture ClockA of ClockE is
  signal Clk1, Clk2, Clk3, Clk4 : std_logic := '0';
begin
  
  Clk1 <= not Clk1 after 1 ns;
  
  process (Clk2)
    variable V2 : natural := 0;
  begin
    V2 := V2+1;
    Clk2 <= not Clk2 after 1 ns;
  end process;  
 
  process 
    variable V31, V32, V33 : natural := 0;
  begin
    v31 := V31+1;
    Clk3 <= '0';                    
    wait for 1 ns;             
    V32 := V32+1;
    Clk3 <= '1';                
    wait for 1 ns;             
    V33 := V33+1;
    if v31 > 3 then
      wait;
    end if;
  end process;
 
  process (Clk4)                               -- falsch!
    variable V4 : natural := 0;
    file file_out : text open write_mode is  "clock.txt"; 
    variable t : time;
  begin
    t := now;
    if t = 0 ns then
      Header(file_out);
    end if;
    v4 := v4+1;    
    Zeile(file_out, 1, t, v4, Clk4);           
    Clk4 <= '0' after 0 ns,
            '1' after 1 ns;
    Zeile(file_out, 2, t, v4, Clk4);           
  end process;
  
  StopSim(10 ns);

end ClockA;
