---------------------------------------------------- shift register
library ieee;
use ieee.std_logic_1164.all;

entity ShiftE is                                    
  port (Clk, Reset, Si: in std_logic;              -- si: serial in                           
        So : out std_logic;                       -- so: serial out
        Po : out Std_logic_vector(3 downto 0)); -- po: parallel out                        
end ShiftE;                             

architecture ShiftA of ShiftE is 
         
begin                                                         

end ShiftA; 

--------------------------------------------------------- testbench
-- pragma synthesis_off 
                            
library ieee;
use ieee.std_logic_1164.all;
use work.UtilPack.all;

entity ShiftTbE is                                           
  generic (ClockT: time:= 1 ns);                            
end ShiftTbE;                                                

architecture ShiftTbA of ShiftTbE is                         
  component ShiftE                      
    port (Clk, Reset, Si: in std_logic;                            
          So : out std_logic;
          Po : out Std_logic_vector(3 downto 0));                                  
  end component;                                             
  signal ClkS, ResetS, SiS, SoS : std_logic := '0'; 
  signal PoS : std_logic_vector(3 downto 0);
begin                                                        
  ShiftI: ShiftE                           
    port map(Clk => ClkS, Reset => ResetS, Si => SiS, So => SoS, Po => PoS);      
                                
  ClkS <= not ClkS after 1*ClockT;

  ResetS <= '1' after 0*ClockT,
            '0' after 2*ClockT;
   
  SiS <= not SiS after 2*ClockT;          
 
  StopSim(20 ns);
        
end ShiftTbA;  
-- pragma synthesis_on     